<?php

namespace fk_\EnumType;

/**
 * This class stands for KReferansTur EnumType
 * @subpackage Enumerations
 */
class KReferansTur
{
    /**
     * Constant for value 'Barkod'
     * @return string 'Barkod'
     */
    const VALUE_BARKOD = 'Barkod';
    /**
     * Constant for value 'Fatura'
     * @return string 'Fatura'
     */
    const VALUE_FATURA = 'Fatura';
    /**
     * Constant for value 'Tesellum'
     * @return string 'Tesellum'
     */
    const VALUE_TESELLUM = 'Tesellum';
    /**
     * Constant for value 'Manifesto'
     * @return string 'Manifesto'
     */
    const VALUE_MANIFESTO = 'Manifesto';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_BARKOD
     * @uses self::VALUE_FATURA
     * @uses self::VALUE_TESELLUM
     * @uses self::VALUE_MANIFESTO
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_BARKOD,
            self::VALUE_FATURA,
            self::VALUE_TESELLUM,
            self::VALUE_MANIFESTO,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
