<?php

namespace fk_\EnumType;

/**
 * This class stands for KargoHareketKaynak EnumType
 * @subpackage Enumerations
 */
class KargoHareketKaynak
{
    /**
     * Constant for value 'MobCihaz'
     * @return string 'MobCihaz'
     */
    const VALUE_MOB_CIHAZ = 'MobCihaz';
    /**
     * Constant for value 'BrkCihaz'
     * @return string 'BrkCihaz'
     */
    const VALUE_BRK_CIHAZ = 'BrkCihaz';
    /**
     * Constant for value 'Serendip'
     * @return string 'Serendip'
     */
    const VALUE_SERENDIP = 'Serendip';
    /**
     * Constant for value 'Sistem'
     * @return string 'Sistem'
     */
    const VALUE_SISTEM = 'Sistem';
    /**
     * Constant for value 'BrkEl'
     * @return string 'BrkEl'
     */
    const VALUE_BRK_EL = 'BrkEl';
    /**
     * Constant for value 'MobEl'
     * @return string 'MobEl'
     */
    const VALUE_MOB_EL = 'MobEl';
    /**
     * Constant for value 'KalkisGeriAlindi'
     * @return string 'KalkisGeriAlindi'
     */
    const VALUE_KALKIS_GERI_ALINDI = 'KalkisGeriAlindi';
    /**
     * Constant for value 'ElTerminali'
     * @return string 'ElTerminali'
     */
    const VALUE_EL_TERMINALI = 'ElTerminali';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_MOB_CIHAZ
     * @uses self::VALUE_BRK_CIHAZ
     * @uses self::VALUE_SERENDIP
     * @uses self::VALUE_SISTEM
     * @uses self::VALUE_BRK_EL
     * @uses self::VALUE_MOB_EL
     * @uses self::VALUE_KALKIS_GERI_ALINDI
     * @uses self::VALUE_EL_TERMINALI
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_MOB_CIHAZ,
            self::VALUE_BRK_CIHAZ,
            self::VALUE_SERENDIP,
            self::VALUE_SISTEM,
            self::VALUE_BRK_EL,
            self::VALUE_MOB_EL,
            self::VALUE_KALKIS_GERI_ALINDI,
            self::VALUE_EL_TERMINALI,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
